package org.eclipse.jdt.internal.compiler.batch;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.io.File;
import org.eclipse.jdt.core.compiler.CharOperation;
import org.eclipse.jdt.internal.compiler.batch.FileSystem;
import org.eclipse.jdt.internal.compiler.env.AccessRestriction;
import org.eclipse.jdt.internal.compiler.env.AccessRuleSet;
import org.eclipse.jdt.internal.compiler.util.SuffixConstants;

public abstract class ClasspathLocation implements FileSystem.Classpath, SuffixConstants {
  public static final int SOURCE = 1;
  
  public static final int BINARY = 2;
  
  String path;
  
  char[] normalizedPath;
  
  public AccessRuleSet accessRuleSet;
  
  public String destinationPath;
  
  protected ClasspathLocation(AccessRuleSet accessRuleSet, String destinationPath) {
    this.accessRuleSet = accessRuleSet;
    this.destinationPath = destinationPath;
  }
  
  protected AccessRestriction fetchAccessRestriction(String qualifiedBinaryFileName) {
    if (this.accessRuleSet == null)
      return null; 
    char[] qualifiedTypeName = qualifiedBinaryFileName
      .substring(0, qualifiedBinaryFileName.length() - SUFFIX_CLASS.length)
      .toCharArray();
    if (File.separatorChar == '\\')
      CharOperation.replace(qualifiedTypeName, File.separatorChar, '/'); 
    return this.accessRuleSet.getViolatedRestriction(qualifiedTypeName);
  }
  
  public int getMode() {
    return 3;
  }
  
  public int hashCode() {
    int result = 1;
    result = 31 * result + getMode();
    result = 31 * result + ((this.path == null) ? 0 : this.path.hashCode());
    return result;
  }
  
  public boolean equals(Object obj) {
    if (this == obj)
      return true; 
    if (obj == null)
      return false; 
    if (getClass() != obj.getClass())
      return false; 
    org.eclipse.jdt.internal.compiler.batch.ClasspathLocation other = (org.eclipse.jdt.internal.compiler.batch.ClasspathLocation)obj;
    String localPath = getPath();
    String otherPath = other.getPath();
    if (localPath == null) {
      if (otherPath != null)
        return false; 
    } else if (!localPath.equals(otherPath)) {
      return false;
    } 
    if (getMode() != other.getMode())
      return false; 
    return true;
  }
  
  public String getPath() {
    return this.path;
  }
}
